#include "Lookupradius.h"
#include <errstr.h>

Lookupradius::Lookupradius(double pn_cts, double pn_offax)
: _pn_cts(pn_cts), _pn_offax(pn_offax)
{
	calRadius();
}


void Lookupradius::calRadius()
{
	// Read external data from LOOKUP.FITS table
	string lookupTable =
		                fileLocator.locate(string("lib/data/lookuptable/") + "LOOKUP.FITS",
		                                    string("Could not locate color table `") + "LOOKUP.FITS'");

		    DataSet *lookup_set = dataSetServer->open(lookupTable, Dal::Read );
		    Table *lookup_tab = lookup_set->table("LOOKUP");
		    unsigned lookup_N = lookup_tab->rows();

		    ColumnData *lookup_cts_low = lookup_tab->column("CTS_LOW")->data();
		    int32 *cts_low = lookup_cts_low->int32Data();
		    ColumnData *lookup_cts_high = lookup_tab->column("CTS_HIGH")->data();
		    int32 *cts_high = lookup_cts_high->int32Data();
		    ColumnData *lookup_radius = lookup_tab->column("RADIUS")->data();
		    real32	   *radius = lookup_radius->real32Data();
		    ColumnData *lookup_offa_low = lookup_tab->column("OFFA_LOW")->data();
		    int32 *offa_low = lookup_offa_low->int32Data();
		    ColumnData *lookup_offa_high = lookup_tab->column("OFFA_HIGH")->data();
		    int32 *offa_high = lookup_offa_high->int32Data();
		    
		    // ---- DEBUG ----
		    // Printout LOOKUP.FITS for testing
		    //for (unsigned long i = 0 ; i < lookup_N ; ++i){
		    //	cout << i << ": " << cts_low[i]<<"	"<< cts_high[i] <<"	"<< radius[i] << "	"<< offa_low[i] << "	"<< offa_high[i]<< std::endl;
		    //}
		    // ---- DEBUG ----


	// Input = _pn_cts, _pn_offax
    	// Filter LOOKUP table by OFF_Axis and CTS limits

		    for (unsigned long i = 0 ; i < lookup_N ; ++i){
		    	if ( offa_low[i] <= _pn_offax && _pn_offax < offa_high[i] ){
		    		
		    			if ( cts_low[i] <= _pn_cts && _pn_cts < cts_high[i] ){
		    				_res = radius[i];  // radius units = arcsec
		    			}
		    	} else {
		    		//
		    	}
		    }
		    // ============>>>> WARNING <<<<<========
		    //
		    //dataSetServer->close(lookup_set);
		    //
		    // ============>>>> WARNING <<<<<========
}


double Lookupradius::getRadius()
{
	return _res;
}
